import ap.SimpleAPI
import ap.parser._
import ap.theories.strings.StringTheory
import ostrich.{OstrichStringTheory, OFlags}

object Hi {
  def main(args: Array[String]) =
    SimpleAPI.withProver { p =>
      import p._
      import IExpression._

      println("Solving string constraints ...")

      val stringTheory = new OstrichStringTheory(List(), OFlags())

      import stringTheory._

      val w = createConstant("w", StringSort)
      val v = createConstant("v", StringSort)
      val u = createConstant("u", StringSort)

      !! (str_in_re(v, re_from_ecma2020("[a-zA-Z]*"))) // regexes
      !! (w === (string2Term("abc") ++ v))             // string concatenation
      !! (u === str_replaceall(w, "a", "x"))           // replacement
      !! (str_contains(u, "y"))                        // containment

      println
      println(???)

      for (va <- List(w, v, u))
        println("" + va + ": \"" + StringTheory.term2String(evalToTerm(va)) + "\"")

      scope {
        println
        !! (str_contains(u, "a"))
        println(???)
      }
      scope {
        println
        !! (str_contains(u, "1"))
        println(???)
      }
  }
}
